%% CODE TO GENERATE THE GRAPHS FOR THE PAPER "ESTIMATING THE GLOBAL SPREAD OF COVID-19"
%V75: to go with the V75 of Vensim to run analysis for the simple model
%V60B: includes two new graphs for Re vs. death and IFR dynamics, and
%updates some stats
%V59: working on V59 model
%V58: same is V57, but for updated V58 model
%V57: to generate results for V3 of the paper, October 2020. Separates
%switches for several pieces of analysis to ensure baseline run can be
%completed without results for sensitivity and validation
%V56 UPDATES: ADDING GRAPH WITH INSET FOR ZERO INFLATED POISSON
%DISTRIBUTION; ENHANCED REPORTING AND ADDITIONAL GRAPH 11, 12, AND VARIOUS
%OUTPUTS FOR V2 OF THE PAPER;
%CHANGE THIS TO ACTIVE DRIVE


%which graphs to draw and what to save
%{
g2: graph for comparing model and data; also showing future projections in
base run for a few countries
%}
scnNm='V75';
runSims=1;  %WHETHER TO RUN SIMULATIONS IN VENSIM
genCode=1; %WHETHER TO GENERATE VENSIM CODE
gon=ones(1,14);%WHICH GRAPHS TO DRAW;
repOn=1;        %WHETHER TO GENERATE THE MAIN REPORT FILErplcRpt=[1,1];      %WHETHER TO REPLACE THE REPORTS OR APPEND TO THEM (FIRST ELEMENT FOR REPORT; SECOND FOR GRAPH REPORTS)
readDt=1; importData=0; %WHEATHER TO READ DATA, OR IMPORT DATA THAT IS ALREADY SAVED IN THE FOLDER
crnDay=868;             %THE LAST DAY CONSIDERED CURRENT IN THE DATASET (868 for 3/1/2022)
maxDay=1540;        %THE MAXIMUM DATE IN DATA
rplcRpt=[1];      %WHETHER TO REPLACE THE REPORT OR APPEND TO THEM (FIRST ELEMENT FOR REPORT)
svGrph=1;       %WHETHER TO SAVE GRAPHS
dateshift=737713;   %  HOW MUCH TO SHIFT THE DAY IN VENSIM TO GET TO CALENDER DATE IN MATLAB

desktop=1;
if desktop
    drvNm='D:\Dropbox (MIT)\COVID-19-TestHealth\Models and Analysis\V75';
else
    drvNm='C:\Users\hazhi\Dropbox (MIT)\COVID-19-TestHealth\Models and Analysis\V75';
end

% name of the files to generate/import
parNm={'','VaxInc','IFRShift','Sw Improved Vaccine','ShiftToNewNormal','ShiftToNewNormal','Variant Accuity Multiplier[Omicron]',...
    'Immunity Loss Time[Vx]','Immunity Loss Time[NVx]','Multiplier Vx Acuity[NVx]'  ,'Multiplier Vx Acuity[Vx]'...
    ,'Variant Transmission Multiplier[Delta]'  ,'Variant Transmission Multiplier[Omicron]',...
    'Variant Vaccine Effectiveness Reduction[Delta]'  ,'Variant Vaccine Effectiveness Reduction[Omicron]'};
parValCh={[],0.5,0.5,1,0.5,1,'els'...
    ,'els','els','els','els'...
    ,'els','els'...
    ,'els','els'};

sensParNm={'','VaxInc','IFRShift','Sw Improved Vaccine','ShiftToNewNormal','ShiftToNewNormal'};
sensParValCh={[],0.5,0.5,1,0.5,1};

rplChar={' ','[',']'};

rplStr=cell(1,numel(parNm));
rplStr(1:end)={rplChar};
parNmSh=cellfun(@erase,parNm,rplStr,'UniformOutput',false);
parValChSh=cellfun(@num2str,sensParValCh,'UniformOutput',false);
runNm=strcat(scnNm,'-',parNmSh);
for i=1:numel(runNm)
    if isnumeric(parValCh{i})
        runNm{i}=strcat(runNm{i},erase(num2str(parValCh{i}),'.'));
    end
end
flNm=strcat(runNm,'.tab');

rplStr=cell(1,numel(sensParNm));
rplStr(1:end)={rplChar};
sensParNmSh=cellfun(@erase,sensParNm,rplStr,'UniformOutput',false);
sensRunNm=strcat(scnNm,'-sens-',sensParNmSh);
for i=1:numel(sensRunNm)
    if isnumeric(sensParValCh{i})
        sensRunNm{i}=strcat(sensRunNm{i},erase(num2str(sensParValCh{i}),'.'));
    end
end
sensFlNm=strcat(sensRunNm,'.tab');

basePol=1;  %run number to be used for extracing variable values for base run

% set list of countries
cntNm={'Albania','Argentina','Australia','Austria','Bahrain','Bangladesh','Belarus','Belgium',...
    'Bolivia','Bulgaria','Canada','Chile','Colombia','CostaRica','Croatia','Cuba','Cyprus',...
    'CzechRepublic','Denmark','DominicanRepublic','Ecuador','ElSalvador','Estonia','Ethiopia','Finland','France','Germany',...
    'Ghana','Greece','Hungary','Iceland','India','Indonesia','Iran','Iraq','Ireland','Israel',...
    'Italy','Jamaica','Japan','Kazakhstan','Kenya','Kuwait','Latvia','Lithuania',...
    'Luxembourg','Madagascar','Malawi','Malaysia','Maldives','Malta','Mexico','Morocco','Mozambique','Nepal',...
    'Netherlands','NewZealand','Nigeria','NorthMacedonia','Norway','Pakistan','Panama','Paraguay','Peru','Philippines',...
    'Poland','Portugal','Qatar','Romania','Russia','Rwanda','SaudiArabia','Senegal','Serbia','Singapore',...
    'Slovakia','Slovenia','SouthAfrica','SouthKorea','Spain','SriLanka','Sweden','Switzerland','Thailand','Togo',...
    'Tunisia','Turkey','UAE','UK','Ukraine','Uruguay','USA','Zambia'...
    };
cntNm2={'Albania','Argentina','Australia','Austria','Bahrain','Bangladesh','Belarus','Belgium',...
    'Bolivia','Bulgaria','Canada','Chile','Colombia','Costa Rica','Croatia','Cuba','Cyprus',...
    'Czech Republic','Denmark','Dominican Republic','Ecuador','El Salvador','Estonia','Ethiopia','Finland','France','Germany',...
    'Ghana','Greece','Hungary','Iceland','India','Indonesia','Iran','Iraq','Ireland','Israel',...
    'Italy','Jamaica','Japan','Kazakhstan','Kenya','Kuwait','Latvia','Lithuania',...
    'Luxembourg','Madagascar','Malawi','Malaysia','Maldives','Malta','Mexico','Morocco','Mozambique','Nepal',...
    'Netherlands','New Zealand','Nigeria','North Macedonia','Norway','Pakistan','Panama','Paraguay','Peru','Philippines',...
    'Poland','Portugal','Qatar','Romania','Russia','Rwanda','Saudi Arabia','Senegal','Serbia','Singapore',...
    'Slovakia','Slovenia','South Africa','South Korea','Spain','Sri Lanka','Sweden','Switzerland','Thailand','Togo',...
    'Tunisia','Turkey','UAE','UK','Ukraine','Uruguay','USA','Zambia'...
    };
% set coloring and market parameters
vmarker={'o','s','d','^','v','*'};
vcolor={'red','blue','green','black','magenta','cyan'};
vcolors={'r','b','g','k','m','c'};
vstyle = {'-','--',':','-.','-'}';

mxPrc=99; %the percentile to use for maximum of graphs
minInf=5;   %minimum number of daily infections to include in the graph
minCml=500;  % minimum number of cumulative cases to include in the graph
CL='%5.0';  %Lower confidence interval width of interest
CH='%95.0'; %Upper confidence interval width of interest
CM='%50.0'; %median CI
left_color=[0 0 1];
right_color=[1 0 0];
flwSl=[1e6 1e6]; %scale factor for flows (per day)
cmlSl=[1e6 1000]; % scale factor for cumulative values


%% setting up basics

cd(drvNm);
numCnt=numel(cntNm);

%% running the simulations
if runSims
    
    
    if genCode
        %% generate vensim models
        
        venModNm='CovidGlobal-Disaggregate-V75-Update.mdl';
        venNm='Vensim - vengine.exe';
        venDir='D:\Dropbox (MIT)\COVID-19-TestHealth\Models and Analysis\Tools\Vensim - vengine 20220301\';
        cmdNm='RunVensim.cmd';
        cmdNmSens='RunVensimSens.cmd';
        %% create the basic structure to go into cmd generator
        
        L.payoff='';
        L.sensitivity='';
        L.optparm='';
        L.savelist='';
        L.senssavelist='';
        L.data='';
        L.changes={'VariantIntroOmicron.out','Updated_main_full.out','V1-Optim.cin','Opt7.out'};
        L.runname='';
        L.setvals='';
        L.runtype='';
        L.export='';
        L.exit=1;
        
        % read global parameters for elastisity analysis
        [Params, strPars,pfval,lb,ub]=parsCalibPars('Updated_main_full.out');
        maxTrial=3;
        %        writeCMD(venModNm,L,cmdNm,'w');
        for i=1:numel(runNm)
            Lb=L;
            Lb.runname={runNm{i}};
            Lb.savelist={'VarsToSaveV75.lst'};
            if ~(strcmp(parNm{i},''))
                if strcmp(parValCh{i},'els')
                    pVal=Params(contains(strPars,parNm{i}))*1.01;
                else
                    pVal=parValCh{i};
                end
                Lb.setvals={[parNm{i} '=' num2str(pVal)]};
            end
            
            Lb.runtype={'run'};
            Lb.export={'',''};
            writeCMD(venModNm,Lb,cmdNm,'w');
            %run the vensim commands
            runVenCmnd(cmdNm,venNm, venDir,flNm{i},'',maxTrial);
            
        end
        %sensitivity analysis commands and runs
        %   writeCMD(venModNm,L,cmdNmSens,'w');
        
        for i=1:numel(sensRunNm)
            Lb=L;
            Lb.runname={sensRunNm{i}};
            Lb.senssavelist={'VarsToSaveV75-sens.lst'};
            if ~(strcmp(sensParNm{i},''))
                if strcmp(sensParValCh{i},'els')
                    pVal=Params(contains(strPars,sensParNm{i}))*1.01;
                else
                    pVal=sensParValCh{i};
                end
                Lb.setvals={[sensParNm{i} '=' num2str(pVal)]};
            end
            Lb.sensitivity={'CovidGlobal-Disaggregate-V75-Update.vsc'};
            Lb.runtype={'sensitivity'};
            Lb.export={'%%#'};
            writeCMD(venModNm,Lb,cmdNmSens,'w');
            %run the vensim commands
            runVenCmnd(cmdNmSens,venNm, venDir,sensFlNm{i},'',maxTrial);
            
        end
    end
end

%% read data
if readDt
    Gt=[];
    St=[];
    
    opts = delimitedTextImportOptions('Delimiter','\t');
    X=readtable(flNm{1},opts);
    varNum=size(X,2);
    opts = delimitedTextImportOptions('NumVariables',varNum,'Delimiter','\t');
    opts.VariableTypes(2:end)={'double'};
    
    for i=1:numel(flNm)
        Gt{i}=readtable(flNm{i},opts);
        Gt{i}(:,varNum+1:end)=[];
    end
    for i=1:numel(sensFlNm)
        St{i}=readtable(sensFlNm{i},opts);
        St{i}(:,varNum+1:end)=[];
    end
    
    save('InputDataGt','Gt');
    
    save('InputDataSt','St');
else
    
    if importData
        load('InputDataGt')
        load('InputDataSt');
    end
end
%% getting country samples in place
pop=[];
rpInf=[];
rpDth=[];

inxDys=table2array(Gt{basePol}(1,2:end))<=crnDay;
inxDay=sum(inxDys); % finding last historial data point
inxDys2=table2array(St{basePol}(1,2:end))<=crnDay;
inxDay2=sum(inxDys2); % finding last historical data point

for i=1:numCnt
    pop(i)=Gt{basePol}{contains(Gt{basePol}.Var1,['Initial Population[' cntNm{i}]),2};
    rpIn=getVenData(Gt{basePol},'DataCmltOverTime',[cntNm{i} ',Infection'],[]);
    rpDt=getVenData(Gt{basePol},'DataCmltOverTime',[cntNm{i} ',Death'],[]);
    rpInf(i)=rpIn(inxDay);
    rpDth(i)=rpDt(inxDay);
end
%cntInx=(pop>3e7 & rpInf>1.5e5); %index of countries for main graph; these need to be adjusted to give us 12 countries
cntInx=(pop>4e7 & rpDth>1.2e5);



%% figure 1: official and actual cases and deaths with projections for a few countries
if gon(1)
    g1Vnm={'SimFlowOverTime','DataFlowOverTime','Infection Rate';'SimFlowOverTime','DataFlowOverTime','Death Rate'};
    g1VnmExt={',Infection',',Infection','';',Death',',Death',''};
    g1Vcnf=[1,0,1;1,0,1];
    for m=1:2 %m is for case vs. death graphs
        for k=2:2 %k is for all countries vs. the sample only
            if k==1
                g1Cnm=cntNm;
                g1Cnm2=cntNm2;
                numRw=11;
            else
                g1Cnm={cntNm{cntInx}};
                g1Cnm2={cntNm2{cntInx}};
                numRw=4;
            end
            g1=figure;
            %numR=floor(numel(g1Cnm)^0.5-0.001)+1;
            %numRw=numR+1;
            numCl=floor((numel(g1Cnm)-0.001)/numRw)+1;
            x_width=numCl*2.5 ;y_width=numRw*1.5;
            set(g1,'Units','inches','Position',[0 0 x_width+1 y_width+1]);
            set(g1,'PaperSize',[x_width+1 y_width+1]);
            ax=[];
            Y1=[];
            ZC1=[];
            ZC2=[];
            
            for i=1:numel(g1Cnm)
                ax{i}=subplot(numRw,numCl,i);
                
                for j=1:size(g1Vnm,2)
                    
                    
                    if g1Vcnf(m,j)==1
                        ZC1(j,:)=getVenData(St{basePol},g1Vnm{m,j},[g1Cnm{i} g1VnmExt{m,j}],CL);
                        ZC2(j,:)=getVenData(St{basePol},g1Vnm{m,j},[g1Cnm{i} g1VnmExt{m,j}],CH);
                        Y1(j,:)=getVenData(St{basePol},g1Vnm{m,j},[g1Cnm{i} g1VnmExt{m,j}],CM);
                        %yy=getVenData(Gt{basePol},g1Vnm{m,j},[g1Cnm{i} g1VnmExt{m,j}],[]); %this is a hack to avoid double names
                        %Y1(j,:)=yy(1,:);
                    else
                        Y1(j,:)=getVenData(Gt{basePol},g1Vnm{m,j},[g1Cnm{i} g1VnmExt{m,j}],[]);
                    end
                end
                %Y1(3,:)=getVenData(Bt{basePol},g1Vnm{3},g1Cnm{i},[]);
                inx=Y1(3,:)>0;
                inx2=inx & inxDys;
                X=table2array(St{basePol}(1,inx));
                dates=X+dateshift;
                X2=table2array(St{basePol}(1,inx2));
                dates2=X2+dateshift;
                pinx=find(cntInx,i);
                gScl=pop(pinx(end))/flwSl(m);
                plot(dates,Y1(1,inx)/gScl,'b','LineWidth',1.5);
                xlim([dates(1) dates(end)]);
                set(ax{i},'XTick',dates(1)+(dates(end)-dates(1))*[0 0.25 0.5 0.75 1])
                datetick(ax{i},'x','mmm yy','keeplimits','keepticks')
                %set(ax{i},'XTick',dates(1)+(dates(end)-dates(1))*[0 0.25 0.5 0.75 1])
                set(ax{i},'XTickLabelRotation',45);
                hold on
                
                %graph with confidence intervals for reported
                plot(dates,ZC1(1,inx)/gScl,'b--','LineWidth',1);
                plot(dates,ZC2(1,inx)/gScl,'b--','LineWidth',1);
                
                % graph for data
                plot(dates2,Y1(2,inx2)/gScl,'r:','LineWidth',1.5);
                
                if m==1
                    yyaxis 'right'
                    
                    % graph for true values
                    plot(dates,Y1(3,inx)/gScl,'k','LineWidth',1.5);
                    plot(dates,ZC1(3,inx)/gScl,'k--','LineWidth',1);
                    plot(dates,ZC2(3,inx)/gScl,'k--','LineWidth',1);
                    
                    ylim([0 prctile(Y1(3,inx)/gScl,90,'all')])
                    ax{i}.YAxis(1).Color = 'b';
                    ax{i}.YAxis(2).Color = 'k';
                else
                    ax{i}.YAxis.Color='k';
                end
                
                xline(crnDay+dateshift,'b--','LineWidth',2);
                
                %            ylim([0 prctile(Y1(3,inx)/cmlSl(1),mxPrc,'all')])
                title(g1Cnm2{i});
                
                
            end
            if m==1
                gPhrz='Infections';
            else
                gPhrz='Deaths';
            end
            if k==1
                sgtitle(['Estimates and Data for Actual and Reported ' gPhrz ' across All Countries']);
            else
                sgtitle(['Estimates and Data for Actual and Reported ' gPhrz]);
            end
            if svGrph
                set(g1, 'PaperUnits', 'inches');
                set(g1, 'PaperPosition', [0 0 x_width y_width]); %
                print(g1,['g1-' num2str(k) '-' gPhrz scnNm ],'-djpeg','-r300');
            end
        end
    end
end

%% Table of parameters and outcomes to put in a file

glbVars={'Global Cases','Global Deaths','Instantaneous IFR Global'};
glbVTms=maxDay*ones(1,numel(glbVars));
glbVPol=[1:numel(parNm)];
glbVVals=cell(numel(glbVars),numel(glbVPol));

optimVars={'Variant IFR Multiplier[Omicron]','Vx IFR Multiplier[Vx]','Vx IFR Multiplier[NVx]'};


rgnVars={'Cumulative Deaths','Cumulative Deaths','CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios'...
    ,'CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios','CumulativeOutcomeRatios'};
rgnVTms=maxDay*ones(1,numel(rgnVars));
rgnVPol={basePol,6,basePol,basePol,2,2,3,3,4,4,5,5};
rgnVSns=ones(size(rgnVars));
rgnVExt={'','',',Death,pd3',',Test,pd3',',Death,pd3',',Test,pd3',',Death,pd3',',Test,pd3',',Death,pd3',',Test,pd3',',Death,pd3',',Test,pd3'};
rgnVScl=[1,1,0,0,0,0,0,0,0,0,0,0];
rgnVVals=zeros(numel(cntNm),numel(rgnVars),3);
%open report
if rplcRpt(1)
    
    fgr=fopen(['Report' scnNm '.txt'],'w'); %file id for recording numbers associated with graphs
    
else
    fgr=fopen(['Report' scnNm '.txt'],'a'); %file id for recording numbers associated with graphs
end

% set the header for report file
fprintf(fgr,'Reporting Country Level Parameters\r\nCountry');
for i=1:numel(rgnVars)
    if rgnVSns(i)==1
        fprintf(fgr,'\t%s\tCL\tCH',[num2str(rgnVScl(i)) rgnVars{i} 'Pol ' num2str(rgnVPol{i})]);
        
    else
        fprintf(fgr,'\t%s',[rgnVars{i} 'Pol ' rgnVPol{i}]);
    end
    
    
end
fprintf(fgr,'\r\n');
for j=1:numel(cntNm)
    fprintf(fgr,'%s',cntNm{j});
    for i=1:numel(rgnVars)
        inxDayR=table2array(Gt{rgnVPol{i}}(1,2:end))==rgnVTms(i);
        if rgnVScl(i)==1
            sclVar=pop(j)/1e6;
        else
            sclVar=1;
        end
        
        if rgnVSns(i)==1
            vm=getVenData(St{rgnVPol{i}},rgnVars{i},[cntNm{j} rgnVExt{i}],CM);
            vl=getVenData(St{rgnVPol{i}},rgnVars{i},[cntNm{j} rgnVExt{i}],CL);
            vh=getVenData(St{rgnVPol{i}},rgnVars{i},[cntNm{j} rgnVExt{i}],CH);
            
            rgnVVals(j,i,:)=[vm(inxDayR)/sclVar,vl(inxDayR)/sclVar,vh(inxDayR)/sclVar];
            
            fprintf(fgr,'\t%2.1f\t%2.1f\t%2.1f',rgnVVals(j,i,1),rgnVVals(j,i,2),rgnVVals(j,i,3));
        else
            vm=getVenData(Gt{rgnVPol{i}},rgnVars{i},[cntNm{j} rgnVExt{i}],[]);
            rgnVVals(j,i,1)=vm(inxDayR)/sclVar;
            fprintf(fgr,'\t%2.1f',rgnVVals(j,i,1));
        end
        
    end
    fprintf(fgr,'\r\n');
end

fprintf(fgr,'%s\t%s','Policy\Variable','value');
for i=1:numel(glbVars)
    fprintf(fgr,'\t%s',glbVars{i});
end
fprintf(fgr,'\r\n');

for j=1:numel(glbVPol)
    fprintf(fgr,'%s',parNm{glbVPol(j)});
    if strcmp(parValCh{glbVPol(j)},'els')
        pval=getVenData(Gt{glbVPol(j)},parNm{glbVPol(j)},[],[]);
        fprintf(fgr,'\t%3.3g',pval(1));
    else
        fprintf(fgr,'\t');
    end
    for i=1:numel(glbVars)
        
        glbVVals{i,j}=getVenData(Gt{glbVPol(j)},glbVars{i},[],[]);
        if strcmp(parValCh{glbVPol(j)},'els')
            fprintf(fgr,'\t%3.3g',(glbVVals{i,j}(1,end)-glbVVals{i,1}(1,end))/glbVVals{i,1}(1,end)*100);
        else
            fprintf(fgr,'\t%3.3g',glbVVals{i,j}(1,end));
        end
    end
    fprintf(fgr,'\r\n');
end

for i=1:numel(optimVars)
     pval=getVenData(Gt{1},optimVars{i},[],[]);
     fprintf(fgr,'%s\t%3.3g\r\n',optimVars{i},pval(1));
           
end

for i=1:numel(cntNm)
    fprintf(fgr,'%s\t%3.3g\r\n',['Population[' cntNm{i} ']'],pop(i));
end

fprintf(fgr,'%s\t%3.3g\r\n','Global Population',sum(pop));

fclose(fgr);


%% figure for all the country level outcomes

if gon(2)
    g2Vars={[1,2;1,1],[3,4;1,1],[5,6;0,0],[7,8;0,0],[9,10;0,0],[11,12;0,0]};
    g2Titles={{'Base vs. No Response';'Cumulative Deaths'},{'Base Trend in';'Deaths & Interactions'},...
        {'Enhanced Vaccination';'Deaths & Interactions'},{'Enhanced Treatment';'Deaths & Interactions'}...
        ,{'Improved Vaccine';'Deaths & Interactions'},{'Shift to New Normal';'Deaths & Interactions'}};
    g2xTitles={{'Deaths per Million';'by end of 2023'},{'2023 average';'relative to 2021'},{'Improvements to Baseline';'2023/2021 Ratio'}...
        ,{'Improvements to Baseline';'2023/2021 Ratio'},{'Improvements to Baseline';'2023/2021 Ratio'},{'Improvements to Baseline';'2023/2021 Ratio'}};
    g2Lims=[20000,2,0.5,1,2,2];
    g2LogAx=[1,0,0,0,0,0];
    g2=figure;
    set(g2,'Units','inches','Position',[0 0 11 8]);
    set(g2,'PaperSize',[11 8]);
    for j=1:numel(g2Vars)
        ax{j}=subplot(1,numel(g2Vars),j);
        
        hold on
        for k=1:size(g2Vars{j},2)
            if g2Vars{j}(2,k)==1
                if j==1
                                    errorbar(squeeze(rgnVVals(:,g2Vars{j}(1,k),1)),[1:numCnt]',squeeze(rgnVVals(:,g2Vars{j}(1,k),1)-rgnVVals(:,g2Vars{j}(1,k),2)),squeeze(rgnVVals(:,g2Vars{j}(1,k),3)-rgnVVals(:,g2Vars{j}(1,k),1)),...
                    vmarker{1},'horizontal','MarkerEdgeColor',vcolor{1+(k-1)*3},'MarkerFaceColor',vcolor{1+(k-1)*3})
                else
                errorbar(squeeze(rgnVVals(:,g2Vars{j}(1,k),1)),[1:numCnt]'+(k-1)/3,squeeze(rgnVVals(:,g2Vars{j}(1,k),1)-rgnVVals(:,g2Vars{j}(1,k),2)),squeeze(rgnVVals(:,g2Vars{j}(1,k),3)-rgnVVals(:,g2Vars{j}(1,k),1)),...
                    vmarker{k},'horizontal','MarkerEdgeColor',vcolor{k},'MarkerFaceColor',vcolor{k})
                end
            else
                hb=barh([1:numCnt]'+(k-1)/3,2*(k-1.5)*(squeeze(rgnVVals(:,g2Vars{j}(1,k),1))-squeeze(rgnVVals(:,g2Vars{2}(1,k),1))),0.3);
                if k==1
                    hb.FaceColor='r';
                    hb.EdgeColor='r';
                else
                    hb.FaceColor='b';
                    hb.EdgeColor='b';
                end
            end
        end
        
        if j==1
            set(ax{j}, 'XScale', 'log')
        end
        ax{j}.YLim=[0 numel(cntNm)+1];
        cSmpll=1:2:numel(cntNm);
        yticks(cSmpll);
        set(ax{j},'yticklabel',[]);
        ax{j}.YColor='k';
        yyaxis right
        ax{j}.YLim=[0 numel(cntNm)+1];
        cSmplr=2:2:numel(cntNm);
        yticks(cSmplr);
        set(ax{j},'yticklabel',[]);
        ax{j}.YColor='k';
        yyaxis left
        
        if j==1
            yticklabels(ax{j},cntNm(cSmpll));
        else
            if j==numel(g2Vars)
                yyaxis right
                yticklabels(ax{j},cntNm(cSmplr));
            else
                set(ax{j},'yticklabel',[]);
            end
        end
        
        if g2LogAx(j)
            set(ax{j}, 'XScale', 'log')
        end
        
        ax{j}.XLim=[max(ax{j}.XLim(1),-g2Lims(j)) g2Lims(j)];
        if j==4
            ax{j}.XLim=[0 g2Lims(j)];
        end
        title(g2Titles{j},'fontsize',9);
        xlabel(g2xTitles{j},'fontsize',8);
        grid on
        
    end
    axSpace=ax{j}.Position(1)+ax{j}.Position(3)-ax{1}.Position(1);
    axStep=axSpace/j;
    axLen=axStep*0.95;
    iniPos=ax{1}.Position(1);
    for i=1:j
        ax{i}.Position(1)=iniPos;
        ax{i}.Position(3)=axLen;
        iniPos=iniPos+axStep;
    end
    if svGrph
        print(g2,['g2-' scnNm ],'-djpeg','-r300');
    end
    
end

%% figure for global cases and deaths under different policies
if gon(3)
    g3=figure;
    lnNum=5;
    g3Leg={'Stable Responsiveness (base)','Enhanced Vaccination','Enhanced Treatment','Improved Vaccine','Shift to New Normal'};
    
    set(g3,'Units','inches','Position',[0 0 8 4]);
    set(g3,'PaperSize',[8 4]);
    inx=glbVVals{1,1}>0;
    
    X=table2array(Gt{basePol}(1,inx));
    dates=X+dateshift;
    gOrder=[lnNum:-1:1];
    for i=1:3
        ax{i}=subplot(2,2,i);
        pltVals=reshape([glbVVals{i,1:lnNum}],[],lnNum);
        switch i
            case 1
            gscl=1e9;
            case 2
            gscl=1e6;
            case 3
                gscl=1e-2;
        end
        hold on
        for j=gOrder
            plot(dates,glbVVals{i,j}(1,inx)/gscl,[vcolors{j} vstyle{j}],'LineWidth',1.5);
        end
        xlim([dates(1) dates(end)]);
        set(ax{i},'XTick',dates(1)+(dates(end)-dates(1))*[0 0.25 0.5 0.75 1])
        datetick(ax{i},'x','mmm yy','keeplimits','keepticks')
        %set(ax{i},'XTick',dates(1)+(dates(end)-dates(1))*[0 0.25 0.5 0.75 1])
        set(ax{i},'XTickLabelRotation',45);
        switch i
            case 1
            title('Cumulative Infections');
            ylabel('Billions of Infections');
            case 2
            title('Cumulative Deaths');
            ylabel('Millions of Deaths');
            case 3
            title('Global IFR');
            ylabel('% (log scale)');
              set(ax{i}, 'YScale', 'log')
                lg=legend(g3Leg(gOrder),'Location','Best','AutoUpdate','off');
                lg.Position(1)=0.6;
               lg.Position(2)=0.15;
                
                
        end
        xline(crnDay+dateshift,'b--','LineWidth',1);
        
        sgtitle('Global Outcomes Under Different Scenarios');
        
    end
    

    if svGrph
        set(g3, 'PaperUnits', 'inches');
        set(g3, 'PaperPosition', [0 0 8 4]); %
        print(g3,['g3-' scnNm ],'-djpeg','-r300');
    end
    
end

